% detecting a linear trend
clear all
close all
alph=0.05;
load('outliers_example.mat');
s=0;
n=size(yo,1);
for i=1:1:n
    x(i)=i;
end
iitel=0;
stap=25;
for w=25:stap:300
 iitel=iitel+1
 i_in=0;
 choose_best=0;
 RMSE_min=1000;
 wintel=0;
 for i=1:1:n-w
         start=i;
         eind=i+w;
         wintel=wintel+1;
         xv=x(start:eind);
         yv=yo(start:eind);
         mdl=fitlm(xv,yv,'linear');
         a(i,iitel)=mdl.Coefficients{1,1};
         b(i,iitel)=mdl.Coefficients{2,1};
         pa(i,iitel)=mdl.Coefficients{1,4};
         pb(i,iitel)=mdl.Coefficients{2,4};
         [rho(i,iitel),p_value(i,iitel)] = corr(xv',yv,'Type','Spearman');
         clear xv yv
         RMSE(i,iitel)=mdl.RMSE;
         if wintel<w+1
             if RMSE(i,iitel)<RMSE_min
                 RMSE_min=RMSE(i,iitel);
                 ibest=i;
             end
         end
         if wintel==w
             %choose best in the past w evaluations
             choose_best=choose_best+1;
             a_b(choose_best,iitel)=a(ibest,iitel);
             b_b(choose_best,iitel)=b(ibest,iitel);
             istart(choose_best,iitel)=ibest;
             ieind(choose_best,iitel)=ibest+w;
             p_a_value(choose_best,iitel)=pa(ibest,iitel);
             p_b_value(choose_best,iitel)=pb(ibest,iitel);
             rho_best(choose_best,iitel)=rho(ibest,iitel);
             confid(choose_best,iitel)=p_value(ibest,iitel);
             RMSE_min=1000;
             wintel=0;

         end
              
     end
end
for j=1:1:iitel
    h=figure;
    subplot(2,1,1);
    plot(yo);
    hold on
    Legend{1}='Original data';
    itel_item=0;
    for i=1:1:size(a_b,1)
        if a_b(i,j)~=0
            itel_item=itel_item+1;
            Legend{itel_item+1}=strcat('Window = ',num2str(50+(j-1)*stap),'p_v_a_l_u_e = ',num2str(p_b_value(i,j)));
            aa=a_b(i,j);
            bb=b_b(i,j);
            xx=[istart(i,j),ieind(i,j)];
            yy=[aa+bb*istart(i,j),aa+bb*((j+1)*stap+istart(i,j))];
            if p_b_value(i,j)<0.025
                plot(xx,yy,'-k');
            else
                plot(xx,yy,'-r');
                hold on
            end
         end
    end
    legend(Legend);
    set(findall(gcf,'-property','FontSize'),'FontSize',14);
    set(findall(gcf,'-property','Font'),'Font','Arial');
    clear Legend;
    subplot(2,1,2)
    hold on
    Legend{1}='Original data';
    clear xx yy
    itel_item=0;
    for i=1:1:size(a_b,1)
        if a_b(i,j)~=0
            itel_item=itel_item+1;
            Legend{itel_item+1}=strcat('Window = ',num2str(50+(j-1)*stap),'p_v_a_l_u_e = ',num2str(p_value(i,j)));
            aa=a_b(i,j);
            bb=b_b(i,j);
            xx=[istart(i,j),ieind(i,j)];
            yy=[confid(i,j),confid(i,j)];
            if p_value(i,j)<alph/2
                plot(xx,yy,'-g');
             if p_value(i,j)>1-alph/2
                  plot(xx,yy,'-r');
             else
                 plot(xx,yy,'-k');
             end

            end
                            hold on
         end
    end
    grid on
    legend(Legend);
    set(findall(gcf,'-property','FontSize'),'FontSize',14);
    set(findall(gcf,'-property','Font'),'Font','Arial');
    clear Legend;
end

pp=normpdf(rho(:,10)*sqrt(1501),0,1);
    